//clase encargada de cargar imagen de los estudiantes

package org.iespuigcastellar.attendancemanager.core;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;

import org.iespuigcastellar.attendancemanager.AttendancemanagerApplication;

import com.vaadin.Application;
import com.vaadin.terminal.ClassResource;
import com.vaadin.terminal.StreamResource;
import com.vaadin.terminal.StreamResource.StreamSource;
import com.vaadin.ui.CustomComponent;
import com.vaadin.ui.Embedded;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import com.vaadin.ui.Upload;
import com.vaadin.ui.VerticalLayout;

public class MyUploader extends CustomComponent
                        implements Upload.SucceededListener,
                                   Upload.FailedListener,
                                   Upload.Receiver {

	private AttendancemanagerApplication app;
//	private Panel root;         // Root element for contained components.
	private Panel imagePanel;   // Panel that contains the uploaded image.
	private File  file;         // File to write to.
	
	private VerticalLayout root;
	private byte[] bytePhotoArray=null;
    private ByteArrayOutputStream baos;
    private String filename;
    private StreamResource imageResource;
	
    public MyUploader() {
//        root = new Panel("");  
        root= new VerticalLayout();
        setCompositionRoot(root);
        // Create the Upload component.
        final Upload upload = new Upload("", this);

        // Use a custom button caption instead of plain "Upload".
		upload.setImmediate(true);
	    upload.setButtonCaption("Selecciona foto");

        // Listen for events regarding the success of upload.
        upload.addListener((Upload.SucceededListener) this);
        upload.addListener((Upload.FailedListener) this);

        root.addComponent(upload);
        // Create a panel for displaying the uploaded image.
        imagePanel = new Panel("");
        imagePanel.setVisible(false);
        root.addComponent(imagePanel);

       
    }


	// Callback method to begin receiving the upload.
    public OutputStream receiveUpload(String filename,
                                      String MIMEType) {
    	this.filename = filename;
    	baos = new ByteArrayOutputStream();

        return baos; // Return the output stream to write to
    }

    // This is called if the upload is finished.
    public void uploadSucceeded(Upload.SucceededEvent event) {
   	
    	//introduxco todo en la array de bytes    	
    	bytePhotoArray = baos.toByteArray();
    	
    	StreamSource streamSource = new StreamSource() {
            public InputStream getStream() {
                if (baos != null) {
                    return new ByteArrayInputStream(bytePhotoArray);
                }
                return null;
            }
        };
        imageResource = new StreamResource(streamSource, filename ,getApplication());

        imagePanel.setVisible(true);
        imagePanel.removeAllComponents();
        imagePanel.addComponent(new Embedded("", imageResource));

    }

    // This is called if the upload fails.
    public void uploadFailed(Upload.FailedEvent event) {

      imagePanel.addComponent(new Label("Fallo"));
      bytePhotoArray=null;

    }
   
	 

	public byte[] getBytePhotoArray() {
		return bytePhotoArray;
	}

	public void setBytePhotoArray(byte[] bytePhotoArray) {
		this.bytePhotoArray = bytePhotoArray;
	}
	
	public void setImageVisibility(boolean value){
		imagePanel.setVisible(value);
		
	}
	
	public boolean isEmpy(){
		return imagePanel.isVisible();
	}
	public void setImagePanel(Student s, Application app){
		
		
		imagePanel.setVisible(true);
	    imagePanel.removeAllComponents();
	    
		if (s.getBytePhotoArray()!=null){
			String id = Integer.toString(s.getID());
			imagePanel.addComponent(new Embedded("", s.getImageResource(app,id)));
	        
		}else{
			imagePanel.addComponent(new Embedded("", new ClassResource("screenlayouts/logininfo/User.png", app)));
		}
 		
	    
	}
}
