/*
    AttendanceManager
    Copyright (C) 2010  Victor Carceler

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
 */

package org.iespuigcastellar.attendancemanager.screenlayouts;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.ResourceBundle;

import org.iespuigcastellar.attendancemanager.AttendancemanagerApplication;
import org.iespuigcastellar.attendancemanager.core.CreatePDF;
import org.iespuigcastellar.attendancemanager.core.DatabaseStorage;
import org.iespuigcastellar.attendancemanager.core.Group;
import org.iespuigcastellar.attendancemanager.core.Mailer;
import org.iespuigcastellar.attendancemanager.core.Miss;
import org.iespuigcastellar.attendancemanager.core.SMS;
import org.iespuigcastellar.attendancemanager.core.NotificationReceipt;

import com.vaadin.data.Item;
import com.vaadin.data.Property;
import com.vaadin.data.Property.ConversionException;
import com.vaadin.data.Property.ReadOnlyException;
import com.vaadin.data.Property.ValueChangeEvent;
import com.vaadin.data.Property.ValueChangeListener;
import com.vaadin.data.util.IndexedContainer;
import com.vaadin.terminal.ThemeResource;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.CheckBox;
import com.vaadin.ui.ComboBox;
import com.vaadin.ui.CustomComponent;
import com.vaadin.ui.Embedded;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import com.vaadin.ui.PopupDateField;
import com.vaadin.ui.Table;
import com.vaadin.ui.TextField;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Window.Notification;

/**
 * @deprecated Ha sido substituida por CommunicationLayout que no 
 * depende de ningún componente no standard.
 *
 */
@Deprecated
@SuppressWarnings("serial")
public class NotifierEmailSmsLayout extends VerticalLayout implements
ValueChangeListener {
	private AttendancemanagerApplication app;
	private ResourceBundle rb = ResourceBundle.getBundle("AttendanceManager");
	private ResourceBundle locale = AttendancemanagerApplication.locale;
	private DatabaseStorage storage = AttendancemanagerApplication.storage;
	//private Teacher user=AttendancemanagerApplication.user;
	
	private ComboBox groupsCombo;
	private ComboBox missesoptionsCombo;
	
	private PopupDateField startDate;
	private PopupDateField endDate;
	
	private Table missTable;
	private IndexedContainer missescontainer;
	
	private Messages messagesmisspanel;
	private Button sendemailbutton;
	private Button sendsmsbutton;
	
	
	private boolean adminMode = false;
	
	public NotifierEmailSmsLayout(boolean adminMode){
		this.adminMode = adminMode;
	}
	
	@SuppressWarnings("static-access")
	public void initLayout(){
		// LAYOUTS 
		//**********TOP**************
		HorizontalLayout toplayout= new HorizontalLayout();
		toplayout.setWidth("100%");
		
		HorizontalLayout combosbuttonslayout =new  HorizontalLayout();
		combosbuttonslayout.setSpacing(true);
		combosbuttonslayout.setMargin(true);
		
		//**********BOTTOM**************
		HorizontalLayout bottomlayout= new HorizontalLayout();
		bottomlayout.setWidth("100%");
		bottomlayout.setHeight("100%");
		bottomlayout.setSpacing(true);
		
		//**********BOTTOM-LEFT*************
		VerticalLayout leftbottomlayout=new VerticalLayout();
		leftbottomlayout.setHeight("100%");
		leftbottomlayout.setSpacing(true);
		
		//**********BOTTOM-RIGHT*************
		VerticalLayout rightbottomlayout=new VerticalLayout();
		rightbottomlayout.setHeight("100%");
		rightbottomlayout.setSpacing(true);
		
		//PANEL TOP
		Panel searchPanel = new Panel(app.locale.getString("NOTIFIEREMAILSMS_SEARCHPANEL_CAPTION"));
		searchPanel.setStyleName("bubble");
		searchPanel.setIcon(new ThemeResource("img/find.png"));
		VerticalLayout searchpanellayout=(VerticalLayout) searchPanel.getContent();;
		searchpanellayout.setMargin(false);
		searchpanellayout.setSizeUndefined();
		
		//PANEL BOTTOM-LEFT
		Panel tablePanel = new Panel(app.locale.getString("NOTIFIEREMAILSMS_TABLEMISSES_CAPTION"));
		tablePanel.setStyleName("bubble");
		tablePanel.setIcon(new ThemeResource("img/user_red.png"));
		tablePanel.getContent().setSizeUndefined();
		VerticalLayout tablepanellayout=(VerticalLayout) tablePanel.getContent();
		tablePanel.setHeight("100%");
		tablepanellayout.setMargin(false);
		tablepanellayout.setSizeFull();
	
		//PANEL BOTTOM-RIGHT
		 messagesmisspanel=new Messages();//this is a Panel Component
		 
		//COMBOS
		groupsCombo = new ComboBox(locale.getString("GROUPMANAGERLAYOUT_GROUPSPANEL_CAPTION"));
		groupsCombo.setNullSelectionAllowed(false);
		groupsCombo.setImmediate(true);
		groupsCombo.setRequired(false);
		groupsCombo.setFilteringMode(ComboBox.FILTERINGMODE_CONTAINS);
		groupsCombo.setReadThrough(true);	
		groupsCombo.setWidth("100%");
		groupsCombo.addListener(this);
		groupsCombo.setSizeUndefined();
		
		missesoptionsCombo = new ComboBox(locale.getString("MESSAGELAYOUT_OPTIONSCOMBOBOX_CAPTION"));
		missesoptionsCombo.setRequiredError(locale.getString("MESSAGELAYOUT_OPTIONSCOMBOBOX_REQUIREDERROR"));
		missesoptionsCombo.setRequired(true);
		missesoptionsCombo.setImmediate(true);
		missesoptionsCombo.setNullSelectionAllowed(false);
		missesoptionsCombo.addListener(this);
		missesoptionsCombo.setSizeUndefined();
			
		//POPUPS DATE
		startDate= new PopupDateField (locale.getString("NOTIFIEREMAILSMS_STARTDATE_CAPTION"));
		startDate.setValue(new java.util.Date());
		startDate.setResolution(PopupDateField.RESOLUTION_DAY);
		startDate.setImmediate(true);
		startDate.addListener(this);
		startDate.setSizeUndefined();
		
		endDate= new PopupDateField (locale.getString("NOTIFIEREMAILSMS_ENDDATE_CAPTION"));
		endDate.setValue(new java.util.Date());
		endDate.setResolution(PopupDateField.RESOLUTION_DAY);
		endDate.setImmediate(true);
		endDate.addListener(this);
		endDate.setSizeUndefined();
		
		//TABLE
		missTable = new Table();
		missTable.setImmediate(true);
		missTable.setSelectable(true);
		missTable.setMultiSelect(true);
		missTable.setColumnReorderingAllowed(true);
		missTable.setColumnCollapsingAllowed(true);
		missTable.setStyleName("striped");
		missTable.setSizeFull();
		
		//BUTTONS + BUTTONS.CLICKLISTENER
		
		sendsmsbutton=new Button(locale.getString("NOTIFIEREMAILSMS_BUTTON_SENDSMS_CAPTION_PREVIEWPANEL"),new Button.ClickListener() {	
			@SuppressWarnings("unchecked")
			@Override
			public void buttonClick(ClickEvent event) {
				Iterator <Integer>iditemiterator=(Iterator<Integer>) messagesmisspanel.getTableItemsIds().iterator();
				String alertdescription="";
				String alertcaptiontring=locale.getString("NOTIFIEREMAILSMS_SMS_ALERT_CAPTION");
				
				Collection<NotificationReceipt> receipts = new ArrayList<NotificationReceipt>();
				
				int i=0;
				while (iditemiterator.hasNext()){
					i++;
					Integer id=iditemiterator.next();
					MessageComponent messagecomponent=(MessageComponent) messagesmisspanel.getTableContainerProperty(id, "message").getValue();
					if (messagecomponent.send()){
						boolean status = messagesmisspanel.sendSms(messagecomponent);
						
						receipts.add(new NotificationReceipt(messagecomponent.getSmsPhone(), status, messagecomponent.getBodyText()));
						
						if(status) { 
							if ("".equals(alertdescription)){
								alertdescription= String.valueOf(i) + ".-" + messagecomponent.getStudentFullName(); 
							}else{
								alertdescription=alertdescription + "<br>" + String.valueOf(i) + ".-" + messagecomponent.getStudentFullName();;
							}
						}
					}
				}
				
				getWindow().showNotification(
						 alertcaptiontring,
		                 alertdescription,
		                 Notification.TYPE_TRAY_NOTIFICATION);
				
				CreatePDF pdf = new CreatePDF();
				app.DownloadFile(getWindow(), pdf.smsList(receipts), "sms-" + System.currentTimeMillis() + ".pdf", AttendancemanagerApplication.MIME_PDF);
			}
		});
		
		
		sendsmsbutton.setStyleName("default");
		sendsmsbutton.setIcon(new ThemeResource("img/sms_16.png"));
		sendsmsbutton.setEnabled(false);
		sendsmsbutton.setDescription(locale.getString("NOTIFIEREMAILSMSLAYOUT_SENDSMSBUTTON_DESCRIPTION"));
	
		sendemailbutton=new Button(locale.getString("NOTIFIEREMAILSMS_BUTTON_SENDMAIL_CAPTION_PREVIEWPANEL"),new Button.ClickListener() {
			@SuppressWarnings("unchecked")
			@Override
			public void buttonClick(ClickEvent event) {
				Iterator <Integer>iditemiterator=(Iterator<Integer>) messagesmisspanel.getTableItemsIds().iterator();
				String alertdescription="";
				String alertcaptiontring= locale.getString("NOTIFIEREMAILSMS_EMAIL_ALERT_CAPTION");
				
				Collection<NotificationReceipt> receipts = new ArrayList<NotificationReceipt>();
				
				int i=0;
				while (iditemiterator.hasNext()){
					i++;
					Integer id=iditemiterator.next();
					MessageComponent messagecomponent=(MessageComponent) messagesmisspanel.getTableContainerProperty(id, "message").getValue();
					if (messagecomponent.send()){
						
						boolean status = messagesmisspanel.sendEmail(messagecomponent);
						
						receipts.add(new NotificationReceipt(messagecomponent.getEmail(), status, messagecomponent.getBodyText()));
						
						if(status) {
							if ("".equals(alertdescription)){
								alertdescription= String.valueOf(i) + ".-" + messagecomponent.getStudentFullName(); 
							}else{
								alertdescription=alertdescription + "<br>" + String.valueOf(i) + ".-" + messagecomponent.getStudentFullName();;
							}
						}
					}
				}
				
				getWindow().showNotification(
						 alertcaptiontring,
		                 alertdescription,
		                 Notification.TYPE_TRAY_NOTIFICATION);
				
				CreatePDF pdf = new CreatePDF();
				app.DownloadFile(getWindow(), pdf.mailList(receipts), "mail-" + System.currentTimeMillis() + ".pdf", AttendancemanagerApplication.MIME_PDF);
			}
		});
		sendemailbutton.setStyleName("default");
		sendemailbutton.setIcon(new ThemeResource("img/email.png"));
		sendemailbutton.setEnabled(false);
		sendemailbutton.setDescription(locale.getString("NOTIFIEREMAILSMSLAYOUT_SENDEMAILBUTTON_DESCRIPTION"));
			
		//ADDING COMPONENTS
		
		//************Adding on top
		combosbuttonslayout.addComponent(groupsCombo);
		combosbuttonslayout.addComponent(startDate);
		combosbuttonslayout.addComponent(endDate);
		combosbuttonslayout.addComponent(missesoptionsCombo);
		combosbuttonslayout.addComponent(sendsmsbutton);
		combosbuttonslayout.addComponent(sendemailbutton);
		combosbuttonslayout.setComponentAlignment(sendsmsbutton, Alignment.BOTTOM_RIGHT);
		combosbuttonslayout.setComponentAlignment(sendemailbutton, Alignment.BOTTOM_RIGHT);
		
		searchPanel.addComponent(combosbuttonslayout);
		toplayout.addComponent(searchPanel);
		
		//************Adding on bottom
		tablePanel.addComponent(missTable);
		leftbottomlayout.addComponent(tablePanel);
		rightbottomlayout.addComponent(messagesmisspanel);
		bottomlayout.addComponent(leftbottomlayout);
		bottomlayout.addComponent(rightbottomlayout);
		
		//EXPANDRATIOS
		leftbottomlayout.setExpandRatio(tablePanel, 1.0f);
		bottomlayout.setExpandRatio(leftbottomlayout, 6.5f);
		bottomlayout.setExpandRatio(rightbottomlayout, 3.5f);
		
		//******adding to this layout (NotifierEmailSmsLayout)*********** 
		addComponent(toplayout);
		addComponent(bottomlayout);
		
		setSizeFull();
		setSpacing(true);
		setMargin(false, true, false,true );
		setExpandRatio(bottomlayout, 1.0f);
	
	}
	
	public void attach(){
		
		app = (AttendancemanagerApplication)getApplication();
		
		initLayout();
		missTable.addContainerProperty(DatabaseStorage.SURNAME1_PROPERTY, String.class, "", locale.getString("GROUPMANAGERLAYOUT_STUDENTGROUPTABLE_SURNAME1"), null,Table.ALIGN_LEFT );
		missTable.addContainerProperty(DatabaseStorage.SURNAME2_PROPERTY, String.class, "", locale.getString("GROUPMANAGERLAYOUT_STUDENTGROUPTABLE_SURNAME2"), null, Table.ALIGN_LEFT);
		missTable.addContainerProperty(DatabaseStorage.NAME_PROPERTY, String.class, "", locale.getString("GROUPMANAGERLAYOUT_GROUPSTABLE_NAME"), null, Table.ALIGN_LEFT);
		missTable.addContainerProperty(DatabaseStorage.EMAIL_PROPERTY, String.class, "",locale.getString("GROUPMANAGERLAYOUT_STUDENTGROUPTABLE_EMAIL"), null, Table.ALIGN_CENTER);
		missTable.addContainerProperty(DatabaseStorage.SMSPHONE_PROPERTY, String.class, "",locale.getString("GROUPMANAGERLAYOUT_STUDENTGROUPTABLE_SMSPHONE"), null,Table.ALIGN_RIGHT);
		missTable.addContainerProperty(DatabaseStorage.MISS_COUNT_PROPERTY, Integer.class, 0,locale.getString("NOTIFIERLAYOUT_MISS_TABLEHEADER"), null, Table.ALIGN_CENTER);
		missTable.addContainerProperty(DatabaseStorage.EXCUSEDMISS_COUNT_PROPERTY, Integer.class, 0,locale.getString("NOTIFIERLAYOUT_EXCUSED_TABLEHEADER"), null,Table.ALIGN_CENTER);
		missTable.addContainerProperty(DatabaseStorage.DELAY_COUNT_PROPERTY, Integer.class, 0,locale.getString("NOTIFIERLAYOUT_DELAY_TABLEHEADER"), null,Table.ALIGN_CENTER);
		missTable.addContainerProperty(DatabaseStorage.EXPULSION_COUNT_PROPERTY, Integer.class, 0,locale.getString("NOTIFIERLAYOUT_EXPULSION_TABLEHEADER"), null,Table.ALIGN_CENTER);
		missTable.addContainerProperty(DatabaseStorage.IMAGE_ALERT_EMAILSEND_PROPERTY, Embedded.class,null,"Email",null,Table.ALIGN_CENTER);
		
		fillGroupsCombo();
		fillTypeMissCombo();
	}
	
	public void valueChange(ValueChangeEvent event) {
		refreshMissTable();
		messagesmisspanel.removeMessages();
		for (Object c:missTable.getItemIds()){
			messagesmisspanel.addMessage(missTable.getItem(c), groupsCombo.getItem(getSelectedGroup()),getStartDate(),getEndDate());
		}
	}
	
	private void fillTypeMissCombo(){
		missesoptionsCombo.addContainerProperty("typemiss", String.class, null);
		String typemiss[]={locale.getString("NOTIFIERLAYOUT_MISS_COMBO"),locale.getString("NOTIFIERLAYOUT_EXCUSED_COMBO"),locale.getString("NOTIFIERLAYOUT_DELAY_COMBO"),locale.getString("NOTIFIERLAYOUT_EXPULSION_COMBO")};
		IndexedContainer typemisscontainer=new IndexedContainer();
		typemisscontainer.addContainerProperty("typemiss", String.class, null);
		Item typemissitem;
		typemissitem=typemisscontainer.addItem(Miss.MISS);
		typemissitem.getItemProperty("typemiss").setValue(typemiss[Miss.MISS-1]);
		typemissitem=typemisscontainer.addItem(Miss.EXCUSED_MISS);
		typemissitem.getItemProperty("typemiss").setValue(typemiss[Miss.EXCUSED_MISS-1]);
		typemissitem=typemisscontainer.addItem(Miss.DELAY);
		typemissitem.getItemProperty("typemiss").setValue(typemiss[Miss.DELAY-1]);
		typemissitem=typemisscontainer.addItem(Miss.EXPULSION);
		typemissitem.getItemProperty("typemiss").setValue(typemiss[Miss.EXPULSION-1]);
		missesoptionsCombo.setContainerDataSource(typemisscontainer);
		missesoptionsCombo.setItemCaptionPropertyId("typemiss");
		missesoptionsCombo.setValue(Miss.MISS);
	}
	
	private void fillGroupsCombo(){
		Collection<Group> collection;
		Integer firstItem=null;
		Item itemGroup=null;
		if (adminMode){
			collection = storage.allGroups();
		}else{
			collection = storage.allGroups(app.user);	
		}
		Iterator<Group> it =collection.iterator();
		IndexedContainer ic=new IndexedContainer();
		ic.addContainerProperty("namegroup", String.class, null);
		while (it.hasNext()){
			Group group=it.next();
			itemGroup=ic.addItem(group.getID());
			itemGroup.getItemProperty("namegroup").setValue(group.getName());
			if (firstItem==null){firstItem=group.getID();}
		}
		groupsCombo.setContainerDataSource(ic);
		groupsCombo.setItemCaptionPropertyId("namegroup");
		groupsCombo.setValue(firstItem);
	}
	
	private void refreshMissTable(){
		Date start=(Date) startDate.getValue();
		Date end=(Date) endDate.getValue();
		if (end.compareTo(start) <0){
			Notification n = new Notification(locale.getString("NOTIFIEREMAILSMSLAYOUT_ERROR_NOTIFICATION_CAPTION"),
					locale.getString("NOTIFIEREMAILSMSLAYOUT_ERROR_NOTIFICATION_DESCRIPTION"),
	                Notification.TYPE_ERROR_MESSAGE);
	        n.setPosition(Notification.POSITION_CENTERED);
	        n.setDelayMsec(500);
	        getWindow().showNotification(n);	
		}else{
			fillIndexedContainer();
			missTable.setContainerDataSource(missescontainer);
		}
	}
	private Date getStartDate(){
		return (Date) startDate.getValue();
	}
	
	private Date getEndDate(){
		return (Date) endDate.getValue();
	}
	
	private Integer getSelectedGroup(){
		return (Integer) groupsCombo.getValue();
	}
	
	@SuppressWarnings("static-access")
	private IndexedContainer getIndexedContainer(){
		IndexedContainer indexedcontainer=new IndexedContainer();
		indexedcontainer.addContainerProperty(app.storage.SURNAME1_PROPERTY,String.class,null);
		indexedcontainer.addContainerProperty(app.storage.SURNAME2_PROPERTY,String.class,null);
		indexedcontainer.addContainerProperty(app.storage.NAME_PROPERTY,String.class,null);
		indexedcontainer.addContainerProperty(app.storage.SMSPHONE_PROPERTY,String.class,null);
		indexedcontainer.addContainerProperty(app.storage.EMAIL_PROPERTY,String.class,null);
		indexedcontainer.addContainerProperty(app.storage.MISS_COUNT_PROPERTY,Integer.class,null);
		indexedcontainer.addContainerProperty(app.storage.EXCUSEDMISS_COUNT_PROPERTY,Integer.class,null);
		indexedcontainer.addContainerProperty(app.storage.DELAY_COUNT_PROPERTY,Integer.class,null);
		indexedcontainer.addContainerProperty(app.storage.EXPULSION_COUNT_PROPERTY,Integer.class,null);

		return indexedcontainer;
	}
	
	public void fillIndexedContainer( ) {	
		if (missescontainer==null){
			missescontainer=getIndexedContainer();
		}else{
			missescontainer.removeAllItems();
		}
		ResultSet r=storage.studentReport1(getSelectedGroup(),getStartDate(),getEndDate());
		try {
			while (r.next()){;
				Item item;
				item = missescontainer.addItem(r.getInt("idstudent"));
				item.getItemProperty(DatabaseStorage.SURNAME1_PROPERTY).setValue(r.getString(DatabaseStorage.SURNAME1_PROPERTY));
				item.getItemProperty(DatabaseStorage.SURNAME2_PROPERTY).setValue(r.getString(DatabaseStorage.SURNAME2_PROPERTY));
				item.getItemProperty(DatabaseStorage.NAME_PROPERTY).setValue(r.getString(DatabaseStorage.NAME_PROPERTY));
				item.getItemProperty(DatabaseStorage.SMSPHONE_PROPERTY).setValue(r.getString(DatabaseStorage.SMSPHONE_PROPERTY));
				item.getItemProperty(DatabaseStorage.EMAIL_PROPERTY).setValue(r.getString(DatabaseStorage.EMAIL_PROPERTY));
				item.getItemProperty(DatabaseStorage.MISS_COUNT_PROPERTY).setValue(r.getInt(DatabaseStorage.MISS_COUNT_PROPERTY));
				item.getItemProperty(DatabaseStorage.EXCUSEDMISS_COUNT_PROPERTY).setValue(r.getInt(DatabaseStorage.EXCUSEDMISS_COUNT_PROPERTY));
				item.getItemProperty(DatabaseStorage.DELAY_COUNT_PROPERTY).setValue(r.getInt(DatabaseStorage.DELAY_COUNT_PROPERTY));
				item.getItemProperty(DatabaseStorage.EXPULSION_COUNT_PROPERTY).setValue(r.getInt(DatabaseStorage.EXPULSION_COUNT_PROPERTY));
			}
			
		} catch (ReadOnlyException e) {
			e.printStackTrace();
		} catch (ConversionException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	private class Messages extends Panel {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		private Table componentstable=new Table();
		
		private SMS sms = new SMS();
		
		public Messages(){				
			componentstable.addContainerProperty(DatabaseStorage.MESSAGE_PREVIEW_PROPERTY, MessageComponent.class, "", locale.getString("NOTIFIEREMAILSMSLAYOUT_TABLE_PREVIEW_MESSAGES_HEADER"), null,Table.ALIGN_LEFT );
			componentstable.setHeight("100%");
			componentstable.setWidth("100%");
			
			addComponent(componentstable);
			VerticalLayout vl=(VerticalLayout) super.getContent();
			vl.setSizeFull();
			vl.setMargin(false);
			vl.setExpandRatio(componentstable, 1.0f);
			
			setCaption(locale.getString("NOTIFIEREMAILSMS_CAPTION_SEARCHPANEL"));
			setIcon(new ThemeResource ("img/magnifier.png"));
			setStyleName("bubble");
			setHeight("100%");
		}
		
		private void addMessage(Item student, Item group, Date start, Date end){
			
			int misstype = 0;
			try {
				misstype = (Integer)missesoptionsCombo.getValue();
			}catch(Exception e) {
				System.out.print("");
			}
			
				MessageComponent messagecomponent = new MessageComponent(student, misstype, start, end);
				if (messagecomponent.getMisses()>0){
					if (!sendemailbutton.isEnabled()){sendemailbutton.setEnabled(true);}
					if (!sendsmsbutton.isEnabled()){sendsmsbutton.setEnabled(true);}
					Integer iditem=componentstable.getItemIds().size();
					Item item=componentstable.addItem(iditem);
					item.getItemProperty("message").setValue(messagecomponent);
				}
			}
			
		private void removeMessages(){
			componentstable.removeAllItems();
			sendemailbutton.setEnabled(false);
			sendsmsbutton.setEnabled(false);
		}
			
		private boolean sendSms(MessageComponent message){
			String phone=message.getSmsPhone();
			String bodytext=message.getBodyText();
			
			return sms.sendSMS(phone, bodytext);
		}
			
		private boolean sendEmail(MessageComponent message){
			Mailer mail = new Mailer();
			String to[]={message.getEmail()};
			mail.setSubject(message.getSubject());
			mail.setFrom(message.getEmailFrom());
			mail.setTo(to);
			mail.setBodyText(message.getBodyText());
			return mail.sendMail();
		}
		
		private Collection<?> getTableItemsIds(){
			return componentstable.getItemIds();
		}
		
		private Property getTableContainerProperty(Object itemId,Object propertyId){
			return componentstable.getContainerProperty(itemId, propertyId);
		}
	}
	
	private class MessageComponent extends CustomComponent{
		private Label fullnamestudentlabel;
		private Label emaillabel;
		private Label phonelabel;
		
		private TextField bodytextfield;
		
		private Item itemstudent;
		
		private CheckBox sendcheckbox;
		
		private Date startdate;
		private Date enddate;
		
		private int misstype;
		
		private SMS sms = new SMS();
		
		public MessageComponent(Item itemstudent, int misstype, Date startdate, Date enddate) {
			VerticalLayout rootlayout=new VerticalLayout();
			this.itemstudent=itemstudent;
			this.startdate=startdate;
			this.enddate=enddate;
			this.misstype=misstype;
			
			sendcheckbox=new CheckBox(locale.getString("NOTIFIEREMAILSMS_CHECKBOX_CAPTION_PREVIEWPANEL"));
			String fullnamestudent="";
			try {
				fullnamestudent=itemstudent.getItemProperty(DatabaseStorage.SURNAME1_PROPERTY).getValue().toString()+" "+ itemstudent.getItemProperty(DatabaseStorage.SURNAME2_PROPERTY).getValue().toString()+", "+ itemstudent.getItemProperty(DatabaseStorage.NAME_PROPERTY).getValue().toString();
			} catch(Exception e) {e.printStackTrace();}
			fullnamestudentlabel=new Label("<img src=\"VAADIN/themes/chamaleon/img/user_red.png\"/><strong>" + locale.getString("NOTIFIEREMAILSMS_MESSAGE_CAPTION_NAME")+" </strong>"+fullnamestudent,Label.CONTENT_XHTML);

			String phoneaddress="";
			try {
				phoneaddress=itemstudent.getItemProperty(DatabaseStorage.SMSPHONE_PROPERTY).getValue().toString();
			} catch(Exception e) {e.printStackTrace();}
			phonelabel=new Label("<img src=\"VAADIN/themes/chamaleon/img/phone.png\"/><strong>" + locale.getString("NOTIFIEREMAILSMS_MESSAGE_CAPTION_PHONE")+" </strong>"+phoneaddress,Label.CONTENT_XHTML);
			
			String emailaddress="";
			try {
				emailaddress=itemstudent.getItemProperty(DatabaseStorage.EMAIL_PROPERTY).getValue().toString();
			} catch(Exception e) {e.printStackTrace();}
			emaillabel=new Label("<img src=\"VAADIN/themes/chamaleon/img/email.png\"/><strong>" + locale.getString("NOTIFIEREMAILSMS_MESSAGE_CAPTION_EMAIL")+" </strong>"+emailaddress,Label.CONTENT_XHTML);

			bodytextfield=new TextField();
			bodytextfield.setRows(6);
			bodytextfield.setWidth("100%");
			//bodytextfield.setMaxLength(Integer.parseInt(rb.getString("sms_max_number")) * 63);
			bodytextfield.setMaxLength(sms.MAX_LENGTH);
			
			setMessage(misstype);
			
		    rootlayout.addComponent(fullnamestudentlabel);
		    rootlayout.addComponent(emaillabel);
		    rootlayout.addComponent(phonelabel);
		    rootlayout.addComponent(bodytextfield);
		    rootlayout.addComponent(sendcheckbox);
		    rootlayout.setMargin(true, false,false,false);
		    setCompositionRoot(rootlayout);
		}
		
		private String getEmail(){
			return itemstudent.getItemProperty(DatabaseStorage.EMAIL_PROPERTY).getValue().toString(); 
		}
		
		private String getSmsPhone(){
			return itemstudent.getItemProperty(DatabaseStorage.SMSPHONE_PROPERTY).getValue().toString();
		}
		
		private String getBodyText(){
			return bodytextfield.getValue().toString();
		}
				
		private String getEmailFrom(){
			return rb.getString("mailer_from").toString();
		}
		
		private String getSubject(){
			return locale.getString("NOTIFIEREMAILSMSLAYOUT_MISSES_SUBJECT_EMAIL").toString();
		}
		
		private boolean send(){
			return ! sendcheckbox.booleanValue();
		}
	
		private String getStudentFullName(){
			return fullnamestudentlabel.getValue().toString();
		}
		private void setMessage(int misstype){
			String message="";
			long dif = startdate.getTime() - enddate.getTime();
			int dies= (int) (dif / 86400000L); // 3600 * 24 * 1000
			
			switch (misstype){
				case 1 ://MissType.MISS:
					if (dies ==0){
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_MISS_MESSAGE"));
					}else{
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_PERIODTIME_MISS_MESSAGE"));
					}
					break;
				case 2: //MissType.EXCUSEDMISS:
					if (dies ==0){
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_EXCUSED_MESSAGE"));
					}else{
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_PERIODTIME_EXCUSED_MESSAGE"));
					}
					break;
				case 3: //MissType.DELAY: break;
					if (dies ==0){
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_DELAY_MESSAGE"));
					}else{
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_PERIODTIME_DELAY_MESSAGE"));
					}
					break;
				case 4://MissType.EXPULSION: break;
					if (dies ==0){
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_EXPULSION_MESSAGE"));;
					}else{
						message=doMessage(locale.getString("NOTIFIEREMAILSMS_PERIODTIME_EXPULSION_MESSAGE"));
					};
					break;
			}
			bodytextfield.setValue(message);
		}
		
		private Integer getMisses(){
			if (misstype==Miss.MISS){return (Integer) itemstudent.getItemProperty(DatabaseStorage.MISS_COUNT_PROPERTY).getValue(); }
			if (misstype==Miss.DELAY){return (Integer) itemstudent.getItemProperty(DatabaseStorage.DELAY_COUNT_PROPERTY).getValue(); }
			if (misstype==Miss.EXCUSED_MISS){return (Integer) itemstudent.getItemProperty(DatabaseStorage.EXCUSEDMISS_COUNT_PROPERTY).getValue(); }
			
			return (Integer) itemstudent.getItemProperty(DatabaseStorage.EXPULSION_COUNT_PROPERTY).getValue();
		}
		
		/**Options :
		 * 	 		%n  : student name
		 *			%s  : space
		 * 		    %s1 : surname 1
		 * 		    %s2 : surname 2
		 *			%m  : misses
		 *			%j  : justificades
		 *			%d  : delays
		 *			%e  : expulsions
		 *          %i : datestart
		 *          %f : dateend
		 *			%v  :NOTIFIER_TIMES_SINGULAR,NOTIFIER_TIMES_PLURAL
		 *			%t  :tutor name
		 *			%l  :newline
		 **/
		private String doMessage(String message){
			SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");  
            String startdatestring = formatter.format(startdate);
            String enddatestring = formatter.format(enddate);
			message=message.replace("%n", itemstudent.getItemProperty(DatabaseStorage.NAME_PROPERTY).getValue().toString())
						   .replace("%s1", itemstudent.getItemProperty(DatabaseStorage.SURNAME1_PROPERTY).getValue().toString())
						   .replace("%s2", itemstudent.getItemProperty(DatabaseStorage.SURNAME2_PROPERTY).getValue().toString())
						   .replace("%m", itemstudent.getItemProperty(DatabaseStorage.MISS_COUNT_PROPERTY).getValue().toString())
						   .replace("%j", itemstudent.getItemProperty(DatabaseStorage.EXCUSEDMISS_COUNT_PROPERTY).getValue().toString())
						   .replace("%d", itemstudent.getItemProperty(DatabaseStorage.DELAY_COUNT_PROPERTY).getValue().toString())
						   .replace("%e", itemstudent.getItemProperty(DatabaseStorage.EXPULSION_COUNT_PROPERTY).getValue().toString())
						   .replace("%i", startdatestring).toString()
						   .replace("%f", enddatestring).toString()	
						   .replace("%t", app.user.getFullname()).toString()
						   .replace("%l", "\n").toString();
			return message;					
		}
	} 	
}